import {afterEach, beforeEach} from 'bun:test'

export const ignoreConsoleErrors = (...messagesToIgnore: string[]) => {
  let consoleError_original: typeof console.error
  beforeEach(() => {
    consoleError_original = console.error
    console.error = (...errorParams: unknown[]) => {
      let message = ''
      if (errorParams[0] instanceof Error) {
        message = errorParams[0].message
      }

      if (typeof errorParams[0] === 'string') {
        message = errorParams[0]
      }

      if (messagesToIgnore.includes(message)) {
        return
      }

      consoleError_original(...errorParams)
    }
  })

  afterEach(() => {
    console.error = consoleError_original
  })
}
