import type {
  RestApiRequestHandler,
  RestApiRoute,
  RestApiRouteHandler,
  RestPathParams,
  RestQueryParams,
  RestRequestBody,
  RestRequestHeaders,
  RestRequireAuthentication,
  RestResponseBody,
} from '../types'

export const buildRestApiRouteHandler = <
  PathParams extends RestPathParams = never,
  QueryParams extends RestQueryParams = never,
  RequestHeaders extends RestRequestHeaders = never,
  RequestBody extends RestRequestBody = never,
  ResponseBody extends RestResponseBody = never,
  RequireAuthentication extends RestRequireAuthentication = false,
>(
  route: RestApiRoute<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>,
  requestHandler: RestApiRequestHandler<
    PathParams,
    QueryParams,
    RequestHeaders,
    RequestBody,
    ResponseBody,
    RequireAuthentication
  >,
): RestApiRouteHandler<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication> => ({
  route,
  requestHandler,
})
