import type {RestApiResponse} from './RestApiResponse'
import type {
  RestPathParams,
  RestQueryParams,
  RestRequestBody,
  RestRequestHeaders,
  RestRequireAuthentication,
  RestResponseBody,
} from './common'
import type {InternalRestApiRequest} from './internal'

export type RestApiRequestHandler<
  PathParams extends RestPathParams = never,
  QueryParams extends RestQueryParams = never,
  RequestHeaders extends RestRequestHeaders = never,
  RequestBody extends RestRequestBody = never,
  ResponseBody extends RestResponseBody = never,
  RequireAuthentication extends RestRequireAuthentication = false,
> = (
  request: InternalRestApiRequest<PathParams, QueryParams, RequestHeaders, RequestBody, RequireAuthentication>,
) => Promise<RestApiResponse<ResponseBody>>
