import type {RestApiRequestHandler} from './RestApiRequestHandler'
import type {RestApiRoute} from './RestApiRoute'
import type {
  RestPathParams,
  RestQueryParams,
  RestRequestBody,
  RestRequestHeaders,
  RestRequireAuthentication,
  RestResponseBody,
} from './common'

export interface RestApiRouteHandler<
  PathParams extends RestPathParams = never,
  QueryParams extends RestQueryParams = never,
  RequestHeaders extends RestRequestHeaders = never,
  RequestBody extends RestRequestBody = never,
  ResponseBody extends RestResponseBody = never,
  RequireAuthentication extends RestRequireAuthentication = false,
> {
  route: RestApiRoute<PathParams, QueryParams, RequestHeaders, RequestBody, ResponseBody, RequireAuthentication>
  requestHandler: RestApiRequestHandler<
    PathParams,
    QueryParams,
    RequestHeaders,
    RequestBody,
    ResponseBody,
    RequireAuthentication
  >
}
