import type {BearerToken} from './BearerToken'
import type {RestRequestHeaders} from './RestRequestHeaders'
import type {RestRequireAuthentication} from './RestRequireAuthentication'

export type AuthorizationHeader = {Authorization: BearerToken}
export type RestRequestHeadersWithAuthorization<
  RequestHeaders extends RestRequestHeaders,
  RequireAuthentication extends RestRequireAuthentication,
> = RequireAuthentication extends true
  ? [RequestHeaders] extends [never]
    ? AuthorizationHeader
    : RequestHeaders & AuthorizationHeader
  : RequestHeaders
