import type {OmitNever} from '../../../types/OmitNever'
import type {RestApiRequest} from '../RestApiRequest'
import type {
  RestPathParams,
  RestQueryParams,
  RestRequestBody,
  RestRequestHeaders,
  RestRequireAuthentication,
} from '../common'

export type InternalRestApiRequest<
  PathParams extends RestPathParams = never,
  QueryParams extends RestQueryParams = never,
  RequestHeaders extends RestRequestHeaders = never,
  RequestBody extends RestRequestBody = never,
  RequireAuthentication extends RestRequireAuthentication = false,
> = OmitNever<
  RestApiRequest<PathParams, QueryParams, RequestHeaders, RequestBody> & {
    userId: RequireAuthentication extends true ? string : never
  }
>
