import {DeleteConnectionCommand} from '@aws-sdk/client-apigatewaymanagementapi'
import type {WsApiConnection} from '../types'
import {getApiGatewayManagementApiClient} from './getApiGatewayManagementApiClient'

export const closeConnection = async ({endpoint, connectionId}: WsApiConnection) => {
  try {
    await getApiGatewayManagementApiClient(endpoint).send(new DeleteConnectionCommand({ConnectionId: connectionId}))
  } catch (err) {
    if (err && typeof err === 'object' && 'name' in err && err?.name === 'GoneException') return

    throw err
  }
}
