import {ApiGatewayManagementApiClient} from '@aws-sdk/client-apigatewaymanagementapi'

const clients: {[endpoint: string]: ApiGatewayManagementApiClient} = {}
export const getApiGatewayManagementApiClient = (endpoint: string): ApiGatewayManagementApiClient => {
  if (clients[endpoint]) return clients[endpoint]

  const client = new ApiGatewayManagementApiClient({endpoint})
  clients[endpoint] = client
  return client
}
